/*

   Java giFT - v0.1.1 (BETA)

   by Steven Tee (aka Pugwash)

   Please use the giFT sourceforge forums on
   http://sf.net/projects/gift to report bugs, get help
   etc. as opposed to contacting me directly.

   This is `free' software, released under the GNU General
   Public License. Please be sure to read this license
   (included in the tarball or available from www.gnu.org)
   before using and distributing copies.

   Note: This applet requires the latest java plugin, if you
   have problems getting it to work in your browser, the
   most likely reason is that its plugin is too old.

   To configure this file, all you need to change is
   serverhost and serverport, as indicated below. You can
   dynamically change these values using param tags in the
   html. See the example HTML file included in the tarball
   for details.

*/

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.*;
import java.net.*;
import javax.swing.*;
import javax.swing.BorderFactory;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.event.*;
import javax.swing.JTable;
import javax.swing.text.*;
import javax.swing.table.TableColumn;
import javax.swing.table.AbstractTableModel;
import java.text.*;
import java.text.Collator;
import java.util.*;

public class giFTjava extends JApplet {

 /***********************************************
  * Edit this to reflect the IP of the machine  *
  * running the giFT deamon. If you load the    *
  * applet from a webserver, this IP also needs *
  * to be the webserver or java will prevent    *
  * the connection. This is overriden by the    *
  * SERVERHOST PARAM tag                        */

    String serverhost = "127.0.0.1";

 /**********************************************
  * Edit this to show the port the deamon is   *
  * running on (default port is 1213). This is *
  * overriden by the SERVERPORT PARAM tag      */

    int serverport = 1213;

 /**********************************************/

    Vector results = new Vector();
    Vector columnNames = new Vector();
    Vector rawdata = new Vector();
    Vector data = new Vector();
    Vector datakey = new Vector();
    Vector dtdata = new Vector();
    Vector hashSearch = new Vector();

    Vector curResults = new Vector();
    Vector threadCntl = new Vector();

    boolean stayconnected = true;
    SwingWorker worker;
    String searchtype;
    String curDownload = "";

    final ThreadTracker threadTracker = new ThreadTracker();

    public void init() {

        super.init();

        String paramhost = getParameter("SERVERHOST");
        String paramport = getParameter("SERVERPORT");

        if(paramhost != null)
            serverhost = paramhost;
        if(paramport != null)
            serverport = Integer.parseInt(paramport);

        Border etched = BorderFactory.createEtchedBorder();
	Border loweredbevel = BorderFactory.createLoweredBevelBorder();
	Border raisedbevel = BorderFactory.createRaisedBevelBorder();


/* @@@@@@@@@@@@@@@@@@@@@@@@@ Search Button Panel @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	final JButton searchButton = new JButton("Start");
	final JButton stopsearchButton = new JButton("Stop");
	stopsearchButton.setEnabled(false);
	JPanel searchPanel = new JPanel();
	searchPanel.setBorder(BorderFactory.createTitledBorder(etched, "Control"));
	searchPanel.setLayout(new GridLayout(2,1));
	searchPanel.add(searchButton);
	searchPanel.add(stopsearchButton);


/* @@@@@@@@@@@@@@@@@@@@@@@@@ Search Critera Panel @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	JLabel keywordLabel = new JLabel("Keywords: ");
	final JTextField keywordField = new JTextField();
	JLabel artistLabel = new JLabel("Artist: ");
	final JTextField artistField = new JTextField(8);
	JLabel titleLabel = new JLabel("Title: ");
	final JTextField titleField = new JTextField(8);
	JLabel albumLabel = new JLabel("Album: ");
	final JTextField albumField = new JTextField(8);
	JLabel yearminLabel = new JLabel(" Year Min: ");
	final JTextField yearminField = new JTextField(2);
	JLabel yearmaxLabel = new JLabel(" Year Max: ");
	final JTextField yearmaxField = new JTextField(2);
	JLabel getresultsLabel = new JLabel(" Results: ");
	String[] resultsSizeStrings = { "10", "20", "50", "100", "200", "All" };
	final JComboBox getresultsList = new JComboBox(resultsSizeStrings);
	getresultsList.setSelectedIndex(3);

	JPanel searchcriteriaPanel = new JPanel();
	searchcriteriaPanel.setBorder(BorderFactory.createTitledBorder(etched, "Search Criteria"));
        GridBagLayout criteriaBag = new GridBagLayout();
        searchcriteriaPanel.setLayout(criteriaBag);
        GridBagConstraints d = new GridBagConstraints();
        d.fill = GridBagConstraints.BOTH;
	d.weighty = 0.0;
	d.weightx = 0.0;
        d.gridx = 0;        d.gridy = 0;
        criteriaBag.setConstraints(keywordLabel, d);	searchcriteriaPanel.add(keywordLabel);
        d.gridx = 1;        d.gridy = 0;	d.gridwidth = 3;
        criteriaBag.setConstraints(keywordField, d);	searchcriteriaPanel.add(keywordField);
        d.gridx = 0;        d.gridy = 1;	d.gridwidth = 1;
        criteriaBag.setConstraints(artistLabel, d);	searchcriteriaPanel.add(artistLabel);
        d.gridx = 1;        d.gridy = 1;	d.weightx = 1.0;
        criteriaBag.setConstraints(artistField, d);	searchcriteriaPanel.add(artistField);
        d.gridx = 0;        d.gridy = 2;	d.weightx = 0.0;
        criteriaBag.setConstraints(titleLabel, d);	searchcriteriaPanel.add(titleLabel);
        d.gridx = 1;        d.gridy = 2;	d.weightx = 1.0;
        criteriaBag.setConstraints(titleField, d);	searchcriteriaPanel.add(titleField);
        d.gridx = 0;        d.gridy = 3;	d.weightx = 0.0;
        criteriaBag.setConstraints(albumLabel, d);	searchcriteriaPanel.add(albumLabel);
        d.gridx = 1;        d.gridy = 3;	d.weightx = 1.0;
        criteriaBag.setConstraints(albumField, d);	searchcriteriaPanel.add(albumField);

	d.gridx = 2;        d.gridy = 1;	d.weightx = 0.0;
        criteriaBag.setConstraints(yearminLabel, d);	searchcriteriaPanel.add(yearminLabel);
	d.gridx = 3;        d.gridy = 1;
        criteriaBag.setConstraints(yearminField, d);	searchcriteriaPanel.add(yearminField);
	d.gridx = 2;        d.gridy = 2;
        criteriaBag.setConstraints(yearmaxLabel, d);	searchcriteriaPanel.add(yearmaxLabel);
	d.gridx = 3;        d.gridy = 2;
        criteriaBag.setConstraints(yearmaxField, d);	searchcriteriaPanel.add(yearmaxField);
	d.gridx = 2;        d.gridy = 3;
        criteriaBag.setConstraints(getresultsLabel, d);	searchcriteriaPanel.add(getresultsLabel);
	d.gridx = 3;        d.gridy = 3;
        criteriaBag.setConstraints(getresultsList, d);	searchcriteriaPanel.add(getresultsList);



/* @@@@@@@@@@@@@@@@@@@@@@@@@ Search File Type Panel @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	JRadioButton audioRadio = new JRadioButton("Audio");
	audioRadio.setActionCommand("Audio");
	JRadioButton imagesRadio = new JRadioButton("Images");
	imagesRadio.setActionCommand("Images");
	JRadioButton videoRadio = new JRadioButton("Video");
	videoRadio.setActionCommand("Video");
	JRadioButton anythingRadio = new JRadioButton("Anything");
	anythingRadio.setActionCommand("Anything");
	JRadioButton softwareRadio = new JRadioButton("Software");
	softwareRadio.setActionCommand("Software");
	JRadioButton documentsRadio = new JRadioButton("Documents");
	documentsRadio.setActionCommand("Documents");

	audioRadio.setSelected(true);
	searchtype = "Audio";

	ButtonGroup radioGroup = new ButtonGroup();
	radioGroup.add(audioRadio);
	radioGroup.add(imagesRadio);
	radioGroup.add(videoRadio);
	radioGroup.add(anythingRadio);
	radioGroup.add(softwareRadio);
	radioGroup.add(documentsRadio);

	JPanel searchfiletypePanel = new JPanel();
	searchfiletypePanel.setBorder(BorderFactory.createTitledBorder(etched, "File Types"));
        GridBagLayout filetypeBag = new GridBagLayout();
        searchfiletypePanel.setLayout(filetypeBag);
        d = new GridBagConstraints();
        d.fill = GridBagConstraints.BOTH;
	d.weighty = 0.0;
	d.weightx = 0.0;
        d.gridx = 0;        d.gridy = 0;
        filetypeBag.setConstraints(audioRadio, d);	searchfiletypePanel.add(audioRadio);
        d.gridx = 0;        d.gridy = 1;
        filetypeBag.setConstraints(imagesRadio, d);	searchfiletypePanel.add(imagesRadio);
        d.gridx = 0;        d.gridy = 2;
        filetypeBag.setConstraints(videoRadio, d);	searchfiletypePanel.add(videoRadio);
        d.gridx = 1;        d.gridy = 0;
        filetypeBag.setConstraints(anythingRadio, d);	searchfiletypePanel.add(anythingRadio);
        d.gridx = 1;        d.gridy = 1;
        filetypeBag.setConstraints(softwareRadio, d);	searchfiletypePanel.add(softwareRadio);
        d.gridx = 1;        d.gridy = 2;
        filetypeBag.setConstraints(documentsRadio, d);	searchfiletypePanel.add(documentsRadio);


/* @@@@@@@@@@@@@@@@@@@@@@@@@ Results Table Panel @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	columnNames.addElement("Type");
	columnNames.addElement("Artist");
	columnNames.addElement("Title");
	columnNames.addElement("Album");
	columnNames.addElement("Dur");
	columnNames.addElement("Size");
	final JTable table = new JTable(data, columnNames);
	table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	TableColumn column = null;
	for (int i = 0; i < 6; i++) {
	    column = table.getColumnModel().getColumn(i);
	    if(i == 0)
		column.setPreferredWidth(60);
	    else if (i == 2)
	        column.setPreferredWidth(400);
	    else if(i == 1 || i == 3)
	        column.setPreferredWidth(200);
	    else if(i == 5)
	        column.setPreferredWidth(80);
	    else
	        column.setPreferredWidth(60);
	}
	table.setRowSelectionAllowed(true);
	table.setColumnSelectionAllowed(false);

	JScrollPane scrollPane = new JScrollPane(table);
	scrollPane.setBorder(etched);


/* @@@@@@@@@@@@@@@@@@@@@@@@@ Status Information Panel @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	Font demoFont = new Font("SansSerif", Font.PLAIN, 11);
	final JButton statusOverviewButton = new JButton("Welcome to giFTjava!");
	statusOverviewButton.setFont(demoFont);
	statusOverviewButton.setBorder(BorderFactory.createTitledBorder(loweredbevel));
	statusOverviewButton.setMargin(new Insets(0,0,0,0));
	final JButton statusUsersButton = new JButton("");
	statusUsersButton.setFont(demoFont);
	statusUsersButton.setBorder(BorderFactory.createTitledBorder(loweredbevel));
	statusUsersButton.setMargin(new Insets(0,0,0,0));
	final JButton statusFilesButton = new JButton("");
	statusFilesButton.setFont(demoFont);
	statusFilesButton.setBorder(BorderFactory.createTitledBorder(loweredbevel));
	statusFilesButton.setMargin(new Insets(0,0,0,0));
	JPanel statusPanel = new JPanel();
        GridBagLayout statusBag = new GridBagLayout();
        statusPanel.setLayout(statusBag);
        d = new GridBagConstraints();
        d.fill = GridBagConstraints.BOTH;
	d.weighty = 0.0;
	d.weightx = 1.0;
	d.insets = new Insets(1,1,0,0);
        d.gridx = 0;        d.gridy = 0;
        statusBag.setConstraints(statusOverviewButton, d);	statusPanel.add(statusOverviewButton);
        d.gridx = 1;        d.gridy = 0;	d.weightx = 0.0;
	statusBag.setConstraints(statusUsersButton, d);		statusPanel.add(statusUsersButton);
        d.gridx = 2;        d.gridy = 0;
	statusBag.setConstraints(statusFilesButton, d);		statusPanel.add(statusFilesButton);



/* @@@@@@@@@@@@@@@@@@@@@@@@@  Download File Tab  @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	JLabel dtFilenameLabel = new JLabel("Filename"); final JTextField dtFilenameField = new JTextField();
	JLabel dtArtistLabel = new JLabel("Artist:");	  final JTextField dtArtistField = new JTextField();
	JLabel dtTitleLabel = new JLabel("Title:");	  final JTextField dtTitleField = new JTextField();
	JLabel dtAlbumLabel = new JLabel("Album:");	  final JTextField dtAlbumField = new JTextField();
	JLabel dtSizeLabel = new JLabel("File Size:");	  final JTextField dtSizeField = new JTextField();
	JLabel dtBitrateLabel = new JLabel("Bitrate:");	  final JTextField dtBitrateField = new JTextField();
	JLabel dtResolLabel = new JLabel("Resolution:");  final JTextField dtResolField = new JTextField();
	JLabel dtGenreLabel = new JLabel("Genre:");	  final JTextField dtGenreField = new JTextField();
	JLabel dtHashLabel = new JLabel("Hashcode:");	  final JTextField dtHashField = new JTextField();
	JLabel dtKeywordLabel = new JLabel("Keywords:");  final JTextField dtKeywordField = new JTextField();
	JLabel dtCommentLabel = new JLabel("Comments:");  final JTextField dtCommentField = new JTextField();
	JLabel dtLengthLabel = new JLabel("Length:");     final JTextField dtLengthField = new JTextField();

	JPanel dtFileinfoPanel = new JPanel();
	dtFileinfoPanel.setBorder(BorderFactory.createTitledBorder(etched, "File Information"));
        GridBagLayout dtFileinfoBag = new GridBagLayout();
        dtFileinfoPanel.setLayout(dtFileinfoBag);
        GridBagConstraints e = new GridBagConstraints();
        e.fill = GridBagConstraints.BOTH;
	e.weighty = 0.0;
	e.weightx = 0.0;
	e.insets = new Insets(2,2,2,2);
        e.gridx = 0;        e.gridy = 0;
        dtFileinfoBag.setConstraints(dtFilenameLabel, e);	dtFileinfoPanel.add(dtFilenameLabel);
        e.gridx = 1;        e.gridy = 0;	e.gridwidth = 3;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtFilenameField, e);	dtFileinfoPanel.add(dtFilenameField);
        e.gridx = 0;        e.gridy = 1;        e.gridwidth = 1;        e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtArtistLabel, e);		dtFileinfoPanel.add(dtArtistLabel);
        e.gridx = 1;        e.gridy = 1;	e.gridwidth = 3;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtArtistField, e);		dtFileinfoPanel.add(dtArtistField);
        e.gridx = 0;        e.gridy = 2;	e.gridwidth = 1;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtTitleLabel, e);		dtFileinfoPanel.add(dtTitleLabel);
        e.gridx = 1;        e.gridy = 2;	e.gridwidth = 3;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtTitleField, e);		dtFileinfoPanel.add(dtTitleField);
        e.gridx = 0;        e.gridy = 3;	e.gridwidth = 1;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtAlbumLabel, e);		dtFileinfoPanel.add(dtAlbumLabel);
        e.gridx = 1;        e.gridy = 3;	e.gridwidth = 3;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtAlbumField, e);		dtFileinfoPanel.add(dtAlbumField);
        e.gridx = 0;        e.gridy = 4;	e.gridwidth = 1;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtSizeLabel, e);		dtFileinfoPanel.add(dtSizeLabel);
        e.gridx = 1;        e.gridy = 4;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtSizeField, e);		dtFileinfoPanel.add(dtSizeField);
        e.gridx = 2;        e.gridy = 4;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtBitrateLabel, e); 	dtFileinfoPanel.add(dtBitrateLabel);
        e.gridx = 3;        e.gridy = 4;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtBitrateField, e); 	dtFileinfoPanel.add(dtBitrateField);
        e.gridx = 0;        e.gridy = 5;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtKeywordLabel, e);	dtFileinfoPanel.add(dtKeywordLabel);
        e.gridx = 1;        e.gridy = 5;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtKeywordField, e);	dtFileinfoPanel.add(dtKeywordField);
        e.gridx = 2;        e.gridy = 5;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtGenreLabel, e);		dtFileinfoPanel.add(dtGenreLabel);
        e.gridx = 3;        e.gridy = 5;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtGenreField, e);		dtFileinfoPanel.add(dtGenreField);
        e.gridx = 0;        e.gridy = 6;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtCommentLabel, e); 	dtFileinfoPanel.add(dtCommentLabel);
        e.gridx = 1;        e.gridy = 6;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtCommentField, e);	dtFileinfoPanel.add(dtCommentField);
	e.gridx = 2;        e.gridy = 6;	e.weightx = 0.0;
	dtFileinfoBag.setConstraints(dtLengthLabel, e);		dtFileinfoPanel.add(dtLengthLabel);
	e.gridx = 3;        e.gridy = 6;	e.weightx = 1.0;
	dtFileinfoBag.setConstraints(dtLengthField, e);		dtFileinfoPanel.add(dtLengthField);
        e.gridx = 0;        e.gridy = 7;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtHashLabel, e);		dtFileinfoPanel.add(dtHashLabel);
        e.gridx = 1;        e.gridy = 7;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtHashField, e);		dtFileinfoPanel.add(dtHashField);
        e.gridx = 2;        e.gridy = 7;	e.weightx = 0.0;
        dtFileinfoBag.setConstraints(dtResolLabel, e);		dtFileinfoPanel.add(dtResolLabel);
        e.gridx = 3;        e.gridy = 7;	e.weightx = 1.0;
        dtFileinfoBag.setConstraints(dtResolField, e);		dtFileinfoPanel.add(dtResolField);

	Vector dtcolumnNames = new Vector();
	dtcolumnNames.addElement("User");
	dtcolumnNames.addElement("URL");

	final JTable dttable = new JTable(dtdata, dtcolumnNames);
	dttable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

	TableColumn dtcolumn = dttable.getColumnModel().getColumn(0);
	dtcolumn.setPreferredWidth(80);
	dtcolumn = dttable.getColumnModel().getColumn(1);
	dtcolumn.setPreferredWidth(400);
	dttable.setRowSelectionAllowed(true);
	dttable.setColumnSelectionAllowed(false);

	JScrollPane dtscrollPane = new JScrollPane(dttable);
	dtscrollPane.setBorder(etched);

	//final JButton findmoreButton = new JButton("Find More Sources");   <-- next release :-)
	//findmoreButton.setEnabled(false);
	final JButton startDownload = new JButton("Download From Selected Source");
	startDownload.setEnabled(false);

	JPanel dtDownloadPanel = new JPanel();
	dtDownloadPanel.setBorder(BorderFactory.createTitledBorder(etched, "Download File"));
        GridBagLayout dtDownloadBag = new GridBagLayout();
        dtDownloadPanel.setLayout(dtDownloadBag);
        GridBagConstraints f = new GridBagConstraints();
        f.fill = GridBagConstraints.BOTH;
	f.weighty = 1.0;
	f.weightx = 1.0;
	f.insets = new Insets(3,3,3,3);
        f.gridx = 0;        f.gridy = 0;	//f.gridwidth = 2;
        dtDownloadBag.setConstraints(dtscrollPane, f);		dtDownloadPanel.add(dtscrollPane);
        f.gridx = 0;        f.gridy = 1;	f.weighty = 0.0;	f.weightx = 0.0;	//f.gridwidth = 1;
        dtDownloadBag.setConstraints(startDownload, f);		dtDownloadPanel.add(startDownload);
        //f.gridx = 1;        f.gridy = 1;
        //dtDownloadBag.setConstraints(findmoreButton, f);	dtDownloadPanel.add(findmoreButton);



/* @@@@@@@@@@@@@@@@@@@@@@@@@  Help Tab  @@@@@@@@@@@@@@@@@@@@@@@@@@ */

        String helphtml;
        helphtml =  ("<html><body bgcolor=#ffffff>");
        helphtml += ("<center><table width=95%><tr><td><font face=SansSerif size=+2>");
        helphtml += ("<br><b>giFTjava v0.1.1 - FAQ</b>");
        helphtml += ("<br><br><font face=SansSerif size=-1><b>Questions</b><br><br>");
        helphtml += ("&nbsp; <a href=#whatis>What is giFTjava?</a><br>");
        helphtml += ("&nbsp; <a href=#whatis>What new features can I expect to see in the shortterm?</a><br>");
        helphtml += ("&nbsp; <a href=#whatis>What features probably won't be implemented soon?</a><br>");
        helphtml += ("&nbsp; <a href=#bug>I've found a bug, what do I do?</a><br>");
        helphtml += ("&nbsp; <a href=#involve>I know Java and would like to get involved, what needs doing?</a><br>");
        helphtml += ("&nbsp; <a href=#hideous>I looked at your sourcecode and it looks hideous!</a><br>");
        helphtml += ("&nbsp; <a href=#contact>Who is it written by?</a><br>");
        helphtml += ("<br><br><b>What is giFTjava?</b><br><br>");
        helphtml += ("giFTjava is a java applet designed to interface with the giFT deamon. ");
        helphtml += ("It is open source, distributed under the GNU General Public License and ");
        helphtml += ("available from http://sf.net/projects/gift (click the button bellow to visit). ");
        helphtml += ("<br><br><br><b>What new features can I expect to see in the shortterm?</b><br><br>");
        helphtml += ("Next release will contain a feature to 'find more sources', so that if you only ");
        helphtml += ("find one or 2 download sites initially you can search for more. The other main ");
        helphtml += ("feature will be the option to message a user. Other than that for the time being ");
        helphtml += ("most other things will be improvement of the interface, extra search options and bug fixes");
        helphtml += ("<br><br><br><b>What features probably won't be implemented soon?</b><br><br>");
        helphtml += ("In a 2 words, parallal downloading. This isn't because I don't know how to ");
        helphtml += ("write the code, but the applet would require access to the users filesystem ");
        helphtml += ("and servers other than the webserver. This would make the applet need to be ");
        helphtml += ("'installed', which goes against the original plan to make a lightweight interface.");
        helphtml += ("<br><br><br><b>I've found a bug, what do I do?</b><br><br>");
        helphtml += ("Its most likely that I know about it already, but just haven't yet gotten ");
        helphtml += ("round to fixing it. Please read the giFT forums and the release notes ");
        helphtml += ("first, then if it has not been reported already post a new message to the ");
        helphtml += ("forum.");
        helphtml += ("<br><br><br><b>I know Java and would like to get involved, what needs doing?</b><br><br>");
        helphtml += ("At the moment I am quite happy working on the applet alone. That doesn't mean ");
        helphtml += ("that nothing needs doing though! The main thing which needs to be sorted ASAP ");
        helphtml += ("is writting reusable classes/javabeans for other people to incorperate into their ");
        helphtml += ("own client application. Please make sure you contact me or one of the giFT developers ");
        helphtml += ("before starting work, there are lots of things in development at the moment and it is ");
        helphtml += ("hard to keep tabs on all that is happening. There is no point in 2 people doing ");
        helphtml += ("exactly the same thing when other areas have not yet been touched. You can find us ");
        helphtml += ("in #gift on irc.sf.net");
        helphtml += ("<br><br><br><b>I looked at your sourcecode and it looks hideous!</b><br><br>");
        helphtml += ("I have only been working on giFT/this code for a week now, so I have had to make some ");
        helphtml += ("compromises in design at this stage in favour of getting a working client out ");
        helphtml += ("to the public. There are many sections of code which I know are not the best way of doing ");
        helphtml += ("things, but at this stage in development it is not as important as whether it works or not. ");
        helphtml += ("Over the comming weeks I will rewrite and restructure the code to make it more ");
        helphtml += ("efficient, fix bugs and add new features. I've only been learning Java for 2 months, so ");
        helphtml += ("go easy on me! :-)");
        helphtml += ("<br><br><br><b>Who is it written by?</b><br><br>");
        helphtml += ("This java applet is written by Steven Tee (aka Pugwash). It interfaces with the giFT deamon ");
        helphtml += ("not Fast Track(tm) servers and hence no reverse engineering of their ");
        helphtml += ("protocol was needed or performed. To contact the author, please do so through ");
        helphtml += ("sourceforge, as opposed emailing to directly. ");
        helphtml += ("<br><br>");
        helphtml += ("</body></html>");
        JEditorPane helpPane = new JEditorPane();
        helpPane.setEditable(false);
        helpPane.setContentType("text/html");
        helpPane.setText(helphtml);
        JScrollPane helpScrollPane = new JScrollPane(helpPane);
        helpScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        JButton helpButton = new JButton("Visit giFT on SourceForge");

        JPanel helpPanel = new JPanel();
        GridBagLayout helpBag = new GridBagLayout();
	helpPanel.setLayout(helpBag);
        GridBagConstraints h = new GridBagConstraints();
        h.fill = GridBagConstraints.BOTH;
	h.weighty = 1.0;
	h.weightx = 1.0;
	//h.insets = new Insets(40,40,10,40);
        h.gridx = 0;        h.gridy = 0;
        helpBag.setConstraints(helpScrollPane, h);		helpPanel.add(helpScrollPane);
        //h.insets = new Insets(0,40,40,40);
        h.gridx = 0;        h.gridy = 1;	h.weighty = 0.0;        h.fill = GridBagConstraints.NONE;
        helpBag.setConstraints(helpButton, h);		helpPanel.add(helpButton);


/* @@@@@@@@@@@@@@@@@@@@@@@@@  Search Control  @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	searchButton.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent f) {
	    SwingWorker addthis = new SwingWorker() {
	      public Object construct() {
                int searchID = threadTracker.addThread();
	        String opts = "";
		statusOverviewButton.setText("Openning connection to deamon");
        	final String keywordString = keywordField.getText();
		if(!(keywordString.equals("")))
		    opts += ("query=\"" + keywordString + "\" ");

	        final String artistString = artistField.getText();
	        if(!(artistString.equals("")))
		    opts += ("artist=\"" + artistString + "\" ");

	        final String titleString = titleField.getText();
	        if(!(titleString.equals("")))
		    opts += ("title=\"" + titleString + "\" ");

		final String albumString = albumField.getText();
		if(!(albumString.equals("")))
		    opts += ("album=\"" + albumString + "\" ");

		final String yearminString = yearminField.getText();
		if(!(yearminString.equals("")))
		    opts += ("year=\"" + yearminString + "\" ");

		final String yearmaxString = yearmaxField.getText();
		if(!(yearmaxString.equals("")))
		    opts += ("year=\"" + yearmaxString + "\" ");

	        String tempstop = (String) getresultsList.getSelectedItem();
	        final int stopatresult;
	        if(tempstop.equals("All"))
		    stopatresult = 9000;
		else
		    stopatresult = Integer.parseInt(tempstop);

	        final String fopts = opts;
	        try {
			System.out.println("Trying to connect");
			Socket giftSocket = new Socket(serverhost, serverport);
                	final PrintWriter out = new PrintWriter(giftSocket.getOutputStream(), true);
                	final BufferedReader in = new BufferedReader(new InputStreamReader(giftSocket.getInputStream()));
			statusOverviewButton.setText("Search started, waiting for results");
			System.out.println("Sending search");
			out.println("<search realm=\"" + searchtype + "\" " + fopts + "/>\r\n");
			System.out.println("Search Started");
			try {
			    String junk = in.readLine();
	  	        } catch(IOException e) { System.out.println("IO Error: " + e); }
			String result;
			String field;
			results.clear();
			stayconnected = true;
			stopsearchButton.setEnabled(true);
			searchButton.setEnabled(false);
			int resultcount = 0;
			while(stayconnected == true) {
                            resultcount++;
			    try {
			      result = in.readLine();
                              if(!(threadTracker.checkAlive(searchID))) {
                                System.out.println("You killed me? WHY!!!! " + searchID); break;
			      } else {
				String hash = "";	String artist = "";
				String title = "";	String album = "";
				String length = "";	String size = "";
				String url = "";	String bandwidth = "";
				String user = "";	String bitrate = "";
				String resolution = "";	String comment = "";
				String genre = "";	String year = "";
				if((result == null) || (resultcount > stopatresult)) {
					stayconnected = false;
					searchButton.setEnabled(true);
					stopsearchButton.setEnabled(false);
					System.out.println("I think the search is over!");
                                        showtable(stopsearchButton, statusOverviewButton, searchButton, table);
					break;
			    	}
			    	result = result.substring(5, (result.length() - 2));
				System.out.println(resultcount);
	    			statusOverviewButton.setText("Search Results so far: " + resultcount);
                            	StringTokenizer Tok = new StringTokenizer(result, "\"");
			    	while (Tok.hasMoreTokens()) {
         			    field = Tok.nextToken();
				    if(field.equals(" HASH="))
      					hash = Tok.nextToken();
				    else if(field.equals(" ARTIST="))
					artist = Tok.nextToken();
				    else if(field.equals(" TITLE="))
					title = Tok.nextToken();
				    else if(field.equals(" ALBUM="))
					album = Tok.nextToken();
				    else if(field.equals(" TIME="))
					length = Tok.nextToken();
				    else if(field.equals(" FILESIZE=")) {
					double unparsedSize = Double.parseDouble(Tok.nextToken());
					if(unparsedSize > 1048576) {
					     size = String.valueOf(unparsedSize / 1048576);
					     if(size.length() > 4)
						size = size.substring(0, 4);
					     size += "Mb";
					} else if(unparsedSize > 1024) {
					     size = String.valueOf(unparsedSize / 1024);
					     if(size.length() > 4)
						size = size.substring(0, 3);
					     size += "Kb";
					} else
					     size = (unparsedSize + "b");
				    }
				    else if(field.equals(" HREF="))
					url = Tok.nextToken();
				    else if(field.equals(" BANDWIDTHTAG="))
					bandwidth = Tok.nextToken();
				    else if(field.equals(" USER="))
					user = Tok.nextToken();
				    else if(field.equals(" BITRATE="))
					bitrate = Tok.nextToken();
				    else if(field.equals(" RESOLUTION="))
					resolution = Tok.nextToken();
				    else if(field.equals(" COMMENT="))
					comment = Tok.nextToken();
				    else if(field.equals(" GENRE="))
					genre = Tok.nextToken();
				    else if(field.equals(" YEAR="))
					year = Tok.nextToken();
     			    	}
 				results.addElement(new String[] {hash, artist, title, album,
						   	     length, size, url, bandwidth, user,
							     bitrate, comment, genre, year,
							     resolution});
                            }
                          } catch(IOException e) { stayconnected = false; System.out.println("problem!");}
                        }
		}
	        catch(IOException e) {
	            System.out.println("IO Error: " + e);
                    statusOverviewButton.setText("IO Error: " + e);
                }
                return "hey swingworker, I have no panties on!";
              }
            };
	    addthis.start();
            threadCntl.addElement(addthis);
	  }
	});

	stopsearchButton.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent f) {
	    statusOverviewButton.setText("Stopping Search.....");
            threadTracker.killThread();
            showtable(stopsearchButton, statusOverviewButton, searchButton, table);
	  }
	});

	startDownload.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent f) {
	    System.out.println(curDownload);
	    try {
		getAppletContext().showDocument(new URL(curDownload), "_blank");
	    }
	    catch (MalformedURLException e) {}
	  }
	});

	helpButton.addActionListener(new ActionListener() {
	  public void actionPerformed(ActionEvent f) {
	    System.out.println("Opening sourceforge site");
	    try {
		getAppletContext().showDocument(new URL("http://sf.net/projects/gift"), "_blank");
	    }
	    catch (MalformedURLException e) {}
	  }
	});

	ListSelectionModel rowSM = table.getSelectionModel();
	rowSM.addListSelectionListener(new ListSelectionListener() {
    	  public void valueChanged(ListSelectionEvent e) {
            if (e.getValueIsAdjusting()) return;
            ListSelectionModel lsm = (ListSelectionModel)e.getSource();
            if (lsm.isSelectionEmpty()) {}
	    else {
                int selectedRow = lsm.getMinSelectionIndex();
		Vector b = (Vector) data.elementAt(selectedRow);
		dtArtistField.setText((String) b.elementAt(1));
		dtTitleField.setText((String) b.elementAt(2));
		dtAlbumField.setText((String) b.elementAt(3));
		dtLengthField.setText((String) b.elementAt(4));
		dtSizeField.setText((String) b.elementAt(5));
		Vector c = (Vector) datakey.elementAt(selectedRow);
		dtHashField.setText((String) c.elementAt(0));
		dtBitrateField.setText((String) c.elementAt(1));
		dtCommentField.setText((String) c.elementAt(2));
		dtGenreField.setText((String) c.elementAt(3));
		//dtYearField.setText((String) c.elementAt(4)); <-- yes i forgot to put a field for it in the GUI :-)
		dtResolField.setText((String) c.elementAt(5));
                hashSearch.clear();
                hashSearch.addElement((String) c.elementAt(0));
                hashSearch.addElement(new Integer(selectedRow));
                dtdata.clear();
		String filename = "";
		Vector d = (Vector) c.elementAt(6);
		for(int i=0; i<d.size(); i++) {
		    String[] sites = (String[]) d.elementAt(i);
		    Vector f = new Vector(); // This is just getting stupid now!!
		    f.addElement(sites[1]);
		    f.addElement(sites[0]);
		    filename = sites[0];
		    dtdata.addElement(f);
		    dttable.updateUI();
		    curDownload = sites[0];
		}
                StringTokenizer Tok = new StringTokenizer(filename, "/");
		while (Tok.hasMoreTokens()) {
        	    filename = Tok.nextToken();
		}
		filename = URLDecoder.decode(filename);
		dtFilenameField.setText(filename);
	    }
   	  }
	});

	ListSelectionModel dtrowSM = dttable.getSelectionModel();
	dtrowSM.addListSelectionListener(new ListSelectionListener() {
    	  public void valueChanged(ListSelectionEvent e) {
            if (e.getValueIsAdjusting()) return;
            ListSelectionModel lsm = (ListSelectionModel)e.getSource();
            if (lsm.isSelectionEmpty()) {
		startDownload.setEnabled(false);
	    }
	    else {
                int selectedRow = lsm.getMinSelectionIndex();
		Vector a = (Vector) dtdata.elementAt(selectedRow);
		curDownload = (String) a.elementAt(1);
		startDownload.setEnabled(true);
	    }
	  }
	});



/* @@@@@@@@@@@@@@@@@@@@@@@@@  Radio Listeners  @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	audioRadio.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent f) {
	    System.out.println("Audio!");
	    searchtype = "Audio";
	  }
	});
	imagesRadio.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent f) {
	    System.out.println("Porn! (Images)");
	    searchtype = "Images";
	  }
	});
	videoRadio.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent f) {
	    System.out.println("Video!");
	    searchtype = "Video";
	  }
	});
	anythingRadio.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent f) {
	    System.out.println("Anything!");
	    searchtype = "Everything";
	  }
	});
	softwareRadio.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent f) {
	    System.out.println("Software!");
	    searchtype = "Software";
	  }
	});
	documentsRadio.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent f) {
	    System.out.println("Documents!");
	    searchtype = "Documents";
	  }
	});


/* @@@@@@@@@@@@@@@@@@@@@@@@@  Put it together and what have you got?  @@@@@@@@@@@@@@@@@@@@@@@@@@ */

	// Some very ugly but working code :-)

	JPanel simpleSearchPane = new JPanel();
        GridBagLayout gridBag = new GridBagLayout();
        simpleSearchPane.setLayout(gridBag);
        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
	c.weighty = 0.0;
	c.weightx = 1.0;
        c.gridx = 0;        c.gridy = 0;
        gridBag.setConstraints(searchcriteriaPanel, c);	simpleSearchPane.add(searchcriteriaPanel);
        c.gridx = 1;        c.gridy = 0;	c.weightx = 0.0;
        gridBag.setConstraints(searchfiletypePanel, c);	simpleSearchPane.add(searchfiletypePanel);
        c.gridx = 2;        c.gridy = 0;
        gridBag.setConstraints(searchPanel, c);	simpleSearchPane.add(searchPanel);
        c.gridx = 0;        c.gridy = 1;	c.weighty = 1.0;	c.gridwidth = 3;
        gridBag.setConstraints(scrollPane, c);	simpleSearchPane.add(scrollPane);
        c.gridx = 0;        c.gridy = 2;	c.weighty = 0.0;	c.gridwidth = 3;
        gridBag.setConstraints(statusPanel, c);	simpleSearchPane.add(statusPanel);

	JPanel downloadPanel = new JPanel();
        GridBagLayout downloadBag = new GridBagLayout();
        downloadPanel.setLayout(downloadBag);
        GridBagConstraints g = new GridBagConstraints();
        g.fill = GridBagConstraints.BOTH;
	g.weighty = 0.0;
	g.weightx = 1.0;
        g.gridx = 0;        g.gridy = 0;
        downloadBag.setConstraints(dtFileinfoPanel, g);	downloadPanel.add(dtFileinfoPanel);
        g.gridx = 0;        g.gridy = 1;	g.weighty = 1.0;
        downloadBag.setConstraints(dtDownloadPanel, g);	downloadPanel.add(dtDownloadPanel);

	JTabbedPane tabbedPane = new JTabbedPane();
        tabbedPane.addTab("File Search", simpleSearchPane);
        tabbedPane.setSelectedIndex(0);
        tabbedPane.addTab("File Download", downloadPanel);
        tabbedPane.addTab("Help", helpPanel);

	Container contentPane = getContentPane();
        GridBagLayout contentgridBag = new GridBagLayout();
        contentPane.setLayout(contentgridBag);
        c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
	c.weighty = 1.0;
	c.weightx = 1.0;
        c.gridx = 0;        c.gridy = 0;
        contentgridBag.setConstraints(tabbedPane, c);	contentPane.add(tabbedPane);
    }

    public void showtable(JButton stopsearchButton, JButton statusOverviewButton, JButton searchButton, JTable table) {
         if(results.size() == 0) {
            System.out.println("No search results found!\n");
	    statusOverviewButton.setText("No search results found");
	    data.clear();
	    table.updateUI();
	}
	else {
	    System.out.println("The search has been stopped/finished, preparing results");
	    statusOverviewButton.setText("Search ended, parsing results");
	    rawdata.clear();
	    data.clear();
	    datakey.clear();
	    Vector temp = new Vector();
	    for(int i=0; i<results.size(); i++) {
		String[] output = (String[]) results.elementAt(i);
		boolean foundhash = false;
		if(temp.size() != 0) {
		    for(int k=0; k<temp.size(); k++) {
			if(output[0].equals((String) temp.elementAt(k))) {
			    foundhash = true;
			    Vector b = (Vector) datakey.elementAt(k);
			    Vector c = (Vector) b.elementAt(6);
			    c.addElement(new String[] {output[6], output[8]});
			    b.setElementAt(c, 6);
			    datakey.setElementAt(b, k);
			}
		    }
		}
		if(!(foundhash)) {
		    temp.addElement(output[0]);
		    Vector d = new Vector();
		    // split output 6 by .
		    StringTokenizer Token = new StringTokenizer(output[6], ".");
		    String filetype = "";
 		    while(Token.hasMoreTokens()) filetype = Token.nextToken();
		    if(filetype.length() > 4) filetype = "";
		    d.addElement(filetype.toUpperCase());
		    d.addElement(output[1]);
		    d.addElement(output[2]);
		    d.addElement(output[3]);
		    d.addElement(output[4]);
		    d.addElement(output[5]);
		    data.addElement(d);

		    Vector e = new Vector();
		    e.addElement(output[0]);
		    e.addElement(output[9]);
		    e.addElement(output[10]);
		    e.addElement(output[11]);
		    e.addElement(output[12]);
		    e.addElement(output[13]);
		    Vector c = new Vector();
		    c.addElement(new String[] {output[6], output[8]});
		    e.addElement(c);
	 	    datakey.addElement(e);
		}
	    }
	    table.updateUI();
	    statusOverviewButton.setText("Results: " + results.size() + "   Unique files: " + temp.size());
	}
	searchButton.setEnabled(true);
	stopsearchButton.setEnabled(false);
    }
}

class ThreadTracker {
    int threadID = 0;
    Vector threadState = new Vector();

    int addThread() {
        threadState.addElement("alive");
        System.out.println("assigned thread " + threadID);
        threadID++;
        return (threadID - 1);
    }

    boolean checkAlive(int iamThread) {
        int threadSize = threadState.size() - 1;
        if(iamThread <= threadSize) {
            String state = (String) threadState.elementAt(iamThread);
            if(state.equals("alive"))
                return true;
        }
        else {
            System.out.println("Internal error, thread checked its status with a dodgy searchID " + iamThread + " " + threadSize);
        }
        return false;
    }

    void killThread() {
        int lastThread = (threadState.size() - 1);
        System.out.println("asked to kill " + lastThread);
        threadState.setElementAt("dead", lastThread);
    }

    void killThread(int threadtoKill) {
        threadState.setElementAt("dead", threadtoKill);
    }
}